10 rem $$asmb=dev1_basic_xox_config_bin,0,10
20 rem $$asmb=dev1_booty_qptr_bin,0,172
30 rem $$asmb=dev1_basic_xox_sprites_bin,0,10
40 rem $$asmb=dev1_booty_outptr_bin,0,10
50 compiled=NOT (is_open(#0))
60 IF NOT compiled
70   SCR_SIZE#0, xsz%,ysz%
80   OUTLN#0,xsz%,ysz%-28,0,28
90   wset -1
100 else
110   open#1,'con'
120   scr_size#1,xsz%,ysz%
130 END IF
140 :
150 IF P_ENV(#1)<>2
160    CLS#1:PRINT#1,"This software works only in the Pointer Environment"
170    a$=INKEY$(#1,-1)
180    STOP
190 END IF
200 :
210 if rmode < 16
220    PRINT#1,"This software works only in high colour mode (8 or 16 bit)"
230    a$=INKEY$(#1,-1)
240    STOP
250 END IF
260 :
270 xsize%=300:ysize%=0
280 init_vars
290 init_wdw
300 main
310 STOP
320 :
330 DEFine PROCedure main
340 LOCal lp%,item%,event%,swnum%,xrel%,yrel%
350   IF compiled
360      DR_PPOS main_defn,-1,-1,main_lfl%
370   ELSE
380      DR_PULD main_defn,-1,-1,main_lfl%
390   END IF
400   scr_chan%=fopen('con')                : rem set up a general screen chan
410   dr_iwdf#scr_chan%,main_defn,2         : rem over info window #3
420   draw_main                                       : rem and draw
430   REPeat lp%
440     RD_PTR main_defn,item%,swnum%,event%,xrel%,yrel%,main_lfl%
450     IF swnum%= -1
460       SELect ON item%
470               =esc%   : EXIT lp%                  : rem quit
480               =1 to 9 : toggle_piece item% : rem hit/do on square
490               = 10    : ch_win main_defn: dr_iwdf#scr_chan%,main_defn,2
500               = 11    : change_size     : rem make new wdw defn
510               = 12    : new_game
520       END SELect
530     endif
540   END REPeat lp%
550   DR_UNST main_defn
560   IF compiled:CLOSE#1
570   RECHP espace_vide                               : rem allocated in lib routine
580 END DEFine main
590 :
600 def proc draw_main
610 local lp%,xo%,yo%,cs%(3)
620   wsipo#scr_chan%,cs%                             : rem get size / orig of screen
630   for lp%=1 to 2
640     WM_BLOCK#scr_chan%,1,cs%(1),(xs%+1)*lp%+lp%,0,sp.3ddark
650     WM_BLOCK#scr_chan%,cs%(0),1,0,(ys%+1)*lp%,sp.3ddark
660   end for lp%
670 end def draw_main
680 :
690 def proc doc
700 rem Click on one: toggles itself - plus:
710 rem corner: all neighbours + center
720 rem middle row: the entire row
730 rem center all but corners
740 end def doc
750 :
760 def proc toggle_center
770 rem center toggles all but the corners
780 local lp%
790  for lp% = 2,4,5,6,8
800    xox%(lp%)=not xox%(lp%)
810  end for lp%
820 end def toggle_center
830 :
840 def proc toggle_col (piece%)
850 local lp%
860   for lp%=piece%-3 to  piece%+3 step 3
870    xox%(lp%)=not xox%(lp%)
880   end for lp%
890 end def toggle_col
900 :
910 def proc toggle_row (piece%)
920 local lp%
930   for lp%=piece%-1 to piece%+1
940    xox%(lp%)=not xox%(lp%)
950   end for lp%
960 end def toggle_row
970 :
980 def proc toggle_ulcorner
990 rem upper left corner hit/done
1000 local lp%
1010   for lp%=1,2,4,5
1020    xox%(lp%)=not xox%(lp%)
1030   end for lp%
1040 end def toggle_ulcorner
1050 :
1060 def proc toggle_urcorner
1070 rem upper right corner hit/done
1080 local lp%
1090   for lp%=2,3,5,6
1100    xox%(lp%)=not xox%(lp%)
1110   end for lp%
1120 end def toggle_ulcorner
1130 :
1140 def proc toggle_llcorner
1150 rem lower left corner hit/done
1160 local lp%
1170   for lp%=4,5,7,8
1180    xox%(lp%)=not xox%(lp%)
1190   end for lp%
1200 end def toggle_llcorner
1210 :
1220 def proc toggle_lrcorner
1230 rem lower right corner
1240 local lp%
1250   for lp%=5,6,8,9
1260    xox%(lp%)=not xox%(lp%)
1270   end for lp%
1280 end def toggle_lrcorner
1290 :
1300 def proc toggle_piece (piece%)
1310 rem toggle the square given as parameter (1 to 9 from left to right)
1320 rem and all associated squares
1330 local dummy
1340   arrcopy xox%,xoxold%
1350   select on piece%
1360     =1:toggle_ulcorner
1370     =2,8:toggle_row piece%
1380     =3:toggle_urcorner
1390     =4,6:toggle_col piece%
1400     =5:toggle_center
1410     =7:toggle_llcorner
1420     =9:toggle_lrcorner
1430   end select
1440   draw_icons
1450   if won%
1460      dr_ldrw main_defn,main_lfl%
1470      dim main_lfl%(main_lit)
1480      dummy=item_select ('You WON!',"Yes, you did!","OK")
1490   endif
1500 end def toggle_pieces
1510 :
1520 def proc draw_icons
1530 rem redraw all the squares
1540 local lp%,icon
1550   for lp%=1 to 9
1560     if xox%(lp%)=xoxold%(lp%):next lp%:exit lp%
1570     if xox%(lp%)
1580       icon=full_sprite
1590     else
1600       icon=zero_sprite
1610     endif
1620     ch_item main_defn,-1,lp%,-1,"",icon
1630     main_lfl%(lp%)=1
1640   end for lp%
1650  rem dr_ldrw main_defn,main_lfl%
1660 rem  dim main_lfl%(main_lit)
1670 end def draw_icons
1680 :
1690 def fn won%
1700 rem returns 1 if won, else 0
1710 local lp%
1720   for lp%=1 to 4,6 to 9
1730     if xox%(lp%)<>1:return 0  : rem all squares marked...
1740   end for lp%
1750   if xox%(5)=1:return 0       : rem ... except center!
1760   return 1                              : rem all ok, so you won!
1770 end def won%
1780 :
1790 def proc new_game
1800 rem sets up a new game
1810 local lp%
1820   for lp%=1 to 9:xox%(lp%)=rnd(0 to 1) :xoxold%(lp%)=not xox%(lp%)
1830   if won%
1840     new_game                    : rem don't set up a winning combination!
1850   else
1860     draw_icons
1870   endif
1880 end def new_game
1890 :
1900 def fn make_sprite (addr,xs3%,ys3%,col)
1910 rem This makes an "aurora fixed palette" sprite.
1920 rem Lines in an aurora sprite must be padded to a long word limit!
1930 rem Since here we use 1 sprite with a full single colour, we can set
1940 rem that up as an RLE1 compressed sprite.
1950 rem The same colour info is used for the "fading" sprite, where we use an
1960 rem alpha mask that "slowly" fades the sprite into background.
1970 rem Parameters are :
1980 rem       the previous address of the sprite, will be rechp'd here.
1990 rem       the x and y sizes of the sprite
2000 rem       the colour of the sprite (aurora type colour)
2010 rem
2020 local patt,mask_full,xs%,ys%,tot,mask_degrad,steps%,lp%,lpx%
2030 local mask_value%,temp,ctlblk,xs2%,ys2%
2040   xs2%=xs3%-4:ys%=ys3%-4
2050   if addr:rechp addr                    : rem release previous sprite
2060   xs%=xs2% mod 4              : rem size of one line        of sprite
2070   if xs%
2080     xs%=4-xs%
2090     xs%=xs2%+xs%              : rem lines are always padded to multiples of 4 bytes
2100   else
2110     xs%=xs2%
2120   endif
2130   tot=xs2%*ys%                          : rem bytes neded for alpha mask (NO PADDING!!!)
2140   tot=tot+(ys%*32)            : rem RLE'd colour - max 16 bytes per row + same for mask
2150   tot=tot+16                            : rem 2* 'RLE1' + 2*length long word
2160   tot=tot+36*3 +20            : rem + header for 3 sprites + sprite control block
2170   addr=alchp(tot)             : rem get mem for sprite
2180   patt=addr+36                          : rem ptr to colour (pattern)
2190   poke addr,2                           : rem sprite mode : GD2
2200   poke addr+1,16              : rem colour: Aurora fixed palette
2210   poke addr+3,64+32+4                   : rem control byte:  RLE patt, alpha mask, sprite block
2220   poke_w addr+4,xs2%
2230   poke_w addr+6,ys%                     : rem x,y sizes
2240   poke_l addr+12,patt-addr-12           : rem pattern
2250 :                                       : rem now make RLE colour pattern
2260   temp=patt                             : rem keep pattern
2270   poke temp,code('R')
2280   poke temp+1,code('L')
2290   poke temp+2,code('E')
2300   poke temp+3,code('1')
2310   tot=xs%*ys%                           : rem uncompressed size
2320   poke_l temp+4,tot                     : rem set it
2330   temp=temp+8
2340   temp%=xs%
2350   make_rle1 xs%,ys%,col,temp  : rem make RLE data now
2360 :
2370   mask_full=temp              : rem point to full mask now
2380   poke mask_full,code('R')
2390   poke mask_full+1,code('L')
2400   poke mask_full+2,code('E')
2410   poke mask_full+3,code('1')  : rem compression marker
2420   poke_l mask_full+4,tot
2430   temp=temp+8
2440   make_rle1 xs%,ys%,-1,temp   : rem compress mask
2450 :                                       : rem now "fading" alpha mask - no compression
2460   mask_degrad=temp            : rem will be "fading sprite" mask
2470   poke_l addr+16,mask_degrad-addr-16
2480   steps%= 255 div xs2%                  : rem how much we fade with each step
2490   for lp%=0 to ys%-1
2500     mask_value%=255                     : rem at beginning of each line, start with opaque mask
2510     for lpx%=0 to xs2%-1
2520       poke temp,mask_value%   : rem value of mask at that pixel
2530       mask_value%=mask_value%-steps%
2540       temp=temp+1             : rem next address
2550     end for lpx%
2560   end for lp%
2570 :                                       : rem now make sprite contol block
2580   if is_odd(temp):temp=temp+1
2590   poke_l addr+28,temp-addr-28           : rem point to it
2600   ctlblk=temp
2610   poke_l ctlblk,addr-ctlblk   : rem point back to first sprite - available
2620   ctlblk=ctlblk+4             : rem pointer to next sprite goes here
2630   temp=temp+20                          : rem header for available + current
2640   poke_l ctlblk,temp-ctlblk   : rem point to it
2650   poke temp,2                           : rem sprite mode : GD2
2660   poke temp+1,16              : rem colour: Aurora fixed palette
2670   poke temp+3,128+64+32       : rem control byte:  RLE patt + mask, alpha mask, sprite block
2680   poke_w temp+4,xs2%
2690   poke_w temp+6,ys%                     : rem sizes
2700   poke_l temp+12,patt-temp-12           : rem pattern
2710   poke_l temp+16,mask_full-temp-16
2720   return addr
2730 end def make_sprite
2740 :
2750 def proc load_sprites
2760   opts_sprite = optson1 + 320           : rem dev1_asm_sprites_8_optsonoff_spr
2770 End def load_sprites
2780 :
2790 def proc make_rle1 (ys%,xs%,col,addr)
2800 rem make RLE1 (byte sized) encoded data, of xs%*ys% nbr of bytes at addr
2810 local tot,temp,lp%
2820   tot = xs%*ys%               : rem total nbr of pixels of same colour
2830   rep lp%
2840     if tot <128
2850        exit lp%               : rem last bytes now
2860     else
2870       poke addr,129                     : rem nbr of same byte
2880       poke addr+1,col                   : rem what byte it is
2890       addr=addr+2             : rem next goes here
2900       tot=tot-128             : rem and remainder of total bytes
2910     endif
2920   end rep lp%
2930   if tot>0
2940     poke addr,257-tot                   : rem how many remaining bytes
2950     poke addr+1,col                     : rem which one is it
2960     addr=addr+2               : rem update address
2970   endif
2980 end def make_rle1
2990 :
3000 def proc init_vars
3010 rem this initialises some (most non window)) global variables
3020 local temp%,lp%
3030   text=0:sprite=2:blob=4:pattern=6
3040   retr=256:retn=-256:sous1=254:sous2=252
3050   hit$=CHR$(1):do$=CHR$(2):cancel$=CHR$(3):sleep$=CHR$(7):wake$=CHR$(8)
3060   help$=CHR$(4):move$=CHR$(5):size$=CHR$(6):cr$=CHR$(10)
3070   lxs=24:lys=12
3080   inf1y=lys+4
3090   xesp=lxs+2
3100   nbr_post%=2
3110   main_coul%=XOXCFG(1)
3120   temp%=set_colours% (2)                : rem always try to set highest colours
3130   if temp%<2 and main_coul%>3:main_coul%=0
3140   make_colours main_coul%
3150   spr_col=XOXCFG(2)
3160   if spr_col>255:spr_col=255
3170   if spr_col<0:spr_col=0
3180 :
3190   randomise
3200   titre$="XoX"
3210   dim xox%(9)
3220   for temp%=1 to 9:xox%(temp%)=rnd (0 to 1)
3230   dim xoxold%(9)
3240   arrcopy xox%,xoxold%
3250 :
3260 restore 3260
3270   DIM std_iattr(3,3)
3280   RD_IATT std_iattr
3290     DATA 0,sp.litemhigh                  : rem item attributes
3300     DATA sp.litemunabg,sp.litemunafg,0,0
3310     DATA sp.litemavabg,sp.litemavafg,0,0
3320     DATA sp.litemselbg,sp.litemselfg,0,0
3330 :
3340   espace_vide=ALCHP(100)
3350 :
3360   main_sprite=RD_SPRT(0)         : REMark normal mask
3370     DATA 11,13,6,5,4
3380     DATA '     www     '
3390     DATA '     waw     '
3400     DATA '     waw     '
3410     DATA '     waw     '
3420     DATA 'wwwwwa awwwww'
3430     DATA 'waaaa   aaaaw'
3440     DATA 'wwwwwa awwwww'
3450     DATA '     waw     '
3460     DATA '     waw     '
3470     DATA '     waw     '
3480     DATA '     www     '
3490 :
3500   move_sprite=6                         : rem use smsq/e system sprites
3510   size_sprite=7
3520   zzz_sprite =10
3530   wake_sprite=11
3540   zero_sprite=RD_SPRT(0)                : rem empty sprite
3550     data 1,1,0,0,4
3560     data "       "
3570 :                                                 : rem dynamically make (!) sprite for squares
3580   load_sprites
3590 :
3600   longueur_titre=LEN(titre$)*6
3610   titre_x=INT((xsize%-longueur_titre)/2): REMark object  x position
3620 :
3630 end def init_vars
3640 :
3650 def proc change_size
3660 local xm%,ym%
3670   ch_win main_defn,xm%,ym%
3680   if xm%=0 and ym%=0:return
3690   close#scr_chan%
3700   dr_unst main_defn
3710   dr_remv main_defn
3720   xsize%=xsize%-xm%
3730   if xsize% > xsz%-50:xsize%=xsz%-50
3740   ysize%=ysize%-ym%
3750   if ysize%>ysz%-20:ysize%=ysz%-20
3760   init_wdw
3770   IF compiled
3780      DR_PPOS main_defn,-1,-1,main_lfl%
3790   ELSE
3800      DR_PULD main_defn,-1,-1,main_lfl%
3810   END IF
3820   scr_chan%=fopen('con')
3830   dr_iwdf#scr_chan%,main_defn,2
3840   draw_main
3850 end def change_size
3860 :
3870 DEFine PROCedure init_wdw
3880 local lp%,size%(1),ori%(1),just%(1),selkey$,type%(1) ,strg$(1)
3890 local s$,spr(0),blb(0),pat(0),count%(1)
3900 if xsize%<300:xsize%=300
3910   xsize%=xsize%-20
3920   xsize%=xsize% div 3
3930   if xsize%>(ysz%-50) div 3:xsize%=(ysz%-50) div 3
3940   if is_odd(xsize%):xsize%=xsize%+1
3950   rem if xsize%<58:xsize%=58
3960   if ysize%=0
3970     ysize%=xsize%
3980   else
3990     if ysize%<240:ysize%=240
4000     ysize%=ysize% - inf1y - 6
4010     ysize%=ysize% div 3
4020   rem  if ysize%> 100:ysize%=100
4030     if ysize%<34:ysize%=38
4040   endif
4050   xs%=xsize%
4060   ys%=ysize%
4070   xsize%=xsize% *3 +12 +4
4080   ysize%=ysize%*3+inf1y + 6
4090   longueur_titre=LEN(titre$)*6
4100   titre_x=INT((xsize%-longueur_titre)/2)
4110   full_sprite=0
4120   full_sprite=make_sprite(full_sprite,xs%,ys%,spr_col)
4130 :
4140 restore 4140
4150 :
4160   main_lit=9+3:DIM main_lfl%(main_lit)
4170   dim size%(main_lit,1),ori%(main_lit,1),just%(main_lit,1),type%(main_lit),strg$(main_lit,20)
4180   dim spr(main_lit),blb(main_lit):selkey$=''
4190   for lp%=0 to 0,10 to main_lit
4200     read size%(lp%,0),size%(lp%,1),ori%(lp%,0),ori%(lp%,1)
4210     read just%(lp%,0),just%(lp%,1)
4220     read s$:selkey$=selkey$&s$
4230     read type%(lp%)
4240     if lp% >0
4250       read spr(lp%-1)
4260     else
4270       read strg$(0)
4280     endif
4290   end for lp%
4300     DATA lxs,lys,xsize%-4-xesp*1,2,0,0,cancel$,text+retr,'ESC'
4310     DATA lxs,lys,4+xesp*0,2,0,0,move$,sprite+retr,move_sprite
4320     DATA lxs,lys,4+xesp*1,2,0,0,size$,sprite+retr,size_sprite
4330     DATA lxs,lys+2,xsize%-4-xesp*2,0,0,0,size$,sprite+retr,opts_sprite
4340   yo%=inf1y:xo%=6
4350   for lp%=1 to 9
4360     size%(lp%,0)=xs%:size%(lp%,1)=ys%
4370     ori%(lp%,0)=xo%:ori%(lp%,1)=yo%
4380     selkey$=selkey$&chr$(0)
4390     type%(lp%)=sprite+retr
4400     if xox%(lp%)
4410       spr(lp%-1)=full_sprite            : rem 'X' = 1
4420     else
4430       spr(lp%-1)=zero_sprite            : rem 0 = empty
4440     endif
4450     xo%=xo%+xs%+2                       : rem +6
4460     if (lp% mod 3) =0
4470       yo%=yo%+ys%+2                               : rem +3
4480       xo%=6                                       : rem 4
4490     endif
4500   end for lp%
4510   main_lot=MK_LIL(std_iattr,size%,ori%,just%,selkey$,type%,strg$,spr,blb,pat)
4520 :
4530 rem now infor wdws
4540   main_iot1=RD_IOT(0)
4550     DATA longueur_titre,10,4,0,text,sp.titlefg,0,0,titre$
4560 :
4570   main_iwt=RD_IWT(2)
4580 :
4590 REMark title bar
4600 :
4610     DATA xsize%-8-(2*nbr_post%*xesp),lys+3,xesp*nbr_post%+4,0
4620     DATA 0,0,sp.infwinbd,sp.titlebg
4630     DATA 0
4640 :
4650 REMark title wdw
4660 :
4670     DATA longueur_titre+8,lys+1,titre_x-4,2
4680     DATA 0,0,sp.infwinbd,sp.titletextbg
4690     DATA main_iot1
4700 :
4710 REMark inner border
4720 :
4730     DATA xsize%-8,ysize%-inf1y-2,4,inf1y
4740     DATA 0,1,sp.infwinbd,sp.infwinbg
4750     DATA 0
4760 :
4770 rem wdw (working) defn
4780 :
4790   main_defn=RD_WDEF
4800     DATA 2,1,sp.winbd,sp.winbg
4810     DATA xsize%,ysize%,10,10
4820     DATA main_sprite,main_lot,main_iwt,0
4830 :
4840 END DEFine init
4850 :
4860 DEFine PROCedure button (def_trav,menu_drap%,app_drap%,control%,chaine$,type_col%)
4870 REMark les parametres sont, dans l'ordre:
4880 REMark la dfinition de la fentre, suivie des tableaux pour
4890 REMark les postes du menu dli, les postes de la sous-fentre d'appl.
4900 REMark et la dfinition de contrle, suivi du nom du bouton et
4910 REMark du type couleurs.
4920 REMark Il est suppos que vous avez ouvert une fentre #1 si
4930 REMark le programme est compil
4940   DR_UNST def_trav
4950   IF compiled: CLOSE#1
4960   button_wait chaine$
4970 rem  BTN chaine$,type_col%
4980   IF compiled
4990     OPEN#1,"CON_"
5000     DR_PPOS def_trav,-1,-1,menu_drap%,app_drap%,control%
5010   ELSE
5020     DR_PULD def_trav,-1,-1,menu_drap%,app_drap%,control%
5030   END IF
5040 END DEFine button
5050 :
5060 DEFine PROCedure make_colours (colourway%)
5070 REMark this initialises the GLOBAL variables menu_pap, menu_brd, menu_inv,
5080 REMark menu_ink and menu_bar according to the colourway passed as parameter.
5090 REMark More importantly, this sets the sp.xxx GLOBAL variables.
5100 REMark The GLOBAl variable mycolour_mode% must have been set prior to calling
5110 REMark this function, preferrably via the function set_colours%.
5120 REMark Moreover the colours black, white,red, green,wg_stripes, etc...
5130 REMark must have been set prior to calling this procedure:
5140 REMark Preferrably, they were also set via the function set_colours%
5150 :
5160 rem this function needs the extension WL_MK16 (outptr_bin)
5170 :
5180 REMark the colourways% are:
5190 REMark 0= white/green
5200 REMark 1= black/red
5210 REMark 2= white/red
5220 REMark 3= black/green
5230 remark 4-7= use system palettes
5240 :
5250 rem the Global war mycolour_mode% is:
5260 rem 0 = we are in QL mode 4
5270 rem 1 = we are in PAL mode (256 colours)
5280 rem 2 - we are in 24 bit colour mode
5290 rem preferrably, this is set via the function set_colours%
5300 :
5310   if colourway%>7 or colourway%<0: colourway%=0: REMark must be between 0 & 7
5320 :
5330 rem first make sure that what we request is possible.
5340 rem colourways 4-7 are only possible if we are in 8 or 24 bit colour mode
5350 rem if it is requested in another mode, it is set to 0
5360 :
5370   if colourway%>3
5380      make_my_palette colourway%-4: rem set colours according to system palette
5390      return                         : rem premature exit
5400   endif
5410 :
5420 rem this now is only the old colourways
5430   select on mycolour_mode%
5440     =0                                  : rem QL 4 colours
5450       SELect ON colourway%
5460           =0:                           : remark white/green
5470                 menu_pap=white
5480                 menu_brd=green
5490                 menu_ink=black
5500                 menu_bar=wg_striped
5510                 menu_inv=red
5520           =1:                           : remark black/red
5530                 menu_pap=black
5540                 menu_brd=red
5550                 menu_ink=white
5560                 menu_bar=br_striped
5570                 menu_inv=green
5580           =2:                           : remark white/red
5590                 menu_pap=white
5600                 menu_brd=red
5610                 menu_ink=black
5620                 menu_bar=wr_striped
5630                 menu_inv=green
5640           =3:                           : remark black/green
5650                 menu_pap=black
5660                 menu_brd=green
5670                 menu_ink=white
5680                 menu_bar=bg_striped
5690                 menu_inv=red
5700       END SELect
5710     =1                                  : rem pal colours
5720       SELect ON colourway%
5730           =0:                           : remark white/green
5740                 menu_pap=white+256
5750                 menu_brd=green+256
5760                 menu_ink=black+256
5770                 menu_bar=wg_striped+256
5780                 menu_inv=red +256
5790           =1:                           : remark black/red
5800                 menu_pap=black+256
5810                 menu_brd=red  +256
5820                 menu_ink=white +256
5830                 menu_bar=br_striped +256
5840                 menu_inv=green +256
5850                 omenu_pap=black+256
5860           =2:                           : remark white/red
5870                 menu_pap=white +256
5880                 menu_brd=red   +256
5890                 menu_ink=black +256
5900                 menu_bar=wr_striped +256
5910                 menu_inv=green +256
5920           =3:                           : remark black/green
5930                 menu_pap=black +256
5940                 menu_brd=green +256
5950                 menu_ink=white +256
5960                 menu_bar=bg_striped +256
5970                 menu_inv=red   +256
5980       END SELect
5990     =2                                  : rem 24 bit colours
6000       SELect ON colourway%
6010           =0:                           : remark white/green
6020                 menu_pap=WL_MK16(white)
6030                 menu_brd=WL_MK16(green)
6040                 menu_ink=WL_MK16(black)
6050                 menu_bar=WL_MK16(wg_striped)
6060                 menu_inv=WL_MK16(red)
6070           =1:                           : remark black/red
6080                 menu_pap=WL_MK16(black)
6090                 menu_brd=WL_MK16(red)
6100                 menu_ink=WL_MK16(white)
6110                 menu_bar=WL_MK16(br_striped)
6120                 menu_inv=WL_MK16(green)
6130           =2:                           : remark white/red
6140                 menu_pap=WL_MK16(white)
6150                 menu_brd=WL_MK16(red)
6160                 menu_ink=WL_MK16(black)
6170                 menu_bar=WL_MK16(wr_striped)
6180                 menu_inv=WL_MK16(green)
6190           =3:                           : remark black/green
6200                 menu_pap=WL_MK16(black)
6210                 menu_brd=WL_MK16(green)
6220                 menu_ink=WL_MK16(white)
6230                 menu_bar=WL_MK16(bg_striped)
6240                 menu_inv=WL_MK16(red)
6250       END SELect
6260   end select
6270 :
6280   make_my_old_palette
6290 :
6300 END DEFine make_colours
6310 :
6320 def proc make_my_palette (cw%)
6330   sp.winbd            = hex('0200') : rem Window border
6340   sp.winbg            = hex('0201') : rem Window background
6350   sp.winfg            = hex('0202') : rem Window foreground
6360   sp.winmg            = hex('0203') : rem Window middleground
6370   sp.titlebg          = hex('0204') : rem Title background
6380   sp.titletextbg  = hex('0205') : rem Title text background
6390   sp.titlefg          = hex('0206') : rem Title foreground
6400   sp.litemhigh        = hex('0207') : rem Loose item highlight
6410   sp.litemavabg   = hex('0208') : rem Loose item available background
6420   sp.litemavafg   = hex('0209') : rem Loose item available foreground
6430   sp.litemselbg   = hex('020a') : rem Loose item selected background
6440   sp.litemselfg   = hex('020b') : rem Loose item selected foreground
6450   sp.litemunabg   = hex('020c') : rem Loose item unavailable background
6460   sp.litemunafg   = hex('020d') : rem Loose item unavailable foreground
6470   sp.infwinbd         = hex('020e') : rem Information window border
6480   sp.infwinbg         = hex('020f') : rem Information window background
6490   sp.infwinfg         = hex('0210') : rem Information window foreground
6500   sp.infwinmg         = hex('0211') : rem Information window middleground
6510   sp.subinfbd         = hex('0212') : rem Subsidiary information window border
6520   sp.subinfbg         = hex('0213') : rem Subsidiary information window background
6530   sp.subinffg         = hex('0214') : rem Subsidiary information window foreground
6540   sp.subinfmg         = hex('0215') : rem Subsidiary information window middleground
6550   sp.appbd            = hex('0216') : rem Application window border
6560   sp.appbg            = hex('0217') : rem Application window background
6570   sp.appfg            = hex('0218') : rem Application window foreground
6580   sp.appmg            = hex('0219') : rem Application window middleground
6590   sp.appihigh         = hex('021a') : rem Application window item highlight
6600   sp.appiavabg        = hex('021b') : rem Application window item available background
6610   sp.appiavafg        = hex('021c') : rem Application window item available foreground
6620   sp.appiselbg        = hex('021d') : rem Application window item selected background
6630   sp.appiselfg        = hex('021e') : rem Application window item selected foreground
6640   sp.appiunabg        = hex('021f') : rem Application window item unavailable background
6650   sp.appiunafg        = hex('0220') : rem Application window item unavailable foreground
6660   sp.scrbar           = hex('0221') : rem Pan/scroll bar
6670   sp.scrbarsec        = hex('0222') : rem Pan/scroll bar section
6680   sp.scrbararr        = hex('0223') : rem Pan/scroll bar arrow
6690   sp.buthigh          = hex('0224') : rem Button highlight
6700   sp.butbd            = hex('0225') : rem Button border
6710   sp.butbg            = hex('0226') : rem Button background
6720   sp.butfg            = hex('0227') : rem Button foreground
6730   sp.hintbd           = hex('0228') : rem Hint border
6740   sp.hintbg           = hex('0229') : rem Hint background
6750   sp.hintfg           = hex('022a') : rem Hint foreground
6760   sp.hintmg           = hex('022b') : rem Hint middleground
6770   sp.errbg            = hex('022c') : rem Error message background
6780   sp.errfg            = hex('022d') : rem Error message foreground
6790   sp.errmg            = hex('022e') : rem Error message middleground
6800   sp.shaded           = hex('022f') : rem sp.shaded area
6810   sp.3ddark           = hex('0230') : rem Dark 3D border shade
6820   sp.3dlight          = hex('0231') : rem Light 3D border shade
6830   sp.vertfill         = hex('0232') : rem Vertical area fill
6840   sp.subtitbg         = hex('0233')  : rem Subtitle background
6850   sp.subtittxtbg  = hex('0234')  : rem Subtitle text background
6860   sp.subtitfg         = hex('0235')  : rem Subtitle foreground
6870   sp.mindexbg         = hex('0236')  : rem Menu index background
6880   sp.mindexfg         = hex('0237')  : rem Menu index foreground
6890   sp.separator        = hex('0238')  : rem Seperator lines etc.
6900   if not (is_open(#0) or is_open(#1))
6910     open#1,'con'
6920     sp_jobpal -1,cw%
6930     close#1
6940   else
6950     sp_jobpal -1,cw%
6960   endif
6970 end def make_my_palette
6980 :
6990 def proc make_my_old_palette
7000 rem this translates the colours used in the wdws into 4 colour mode...
7010   sp.winbd          =         menu_ink   : rem Window border
7020   sp.winbg          =         menu_pap   : rem Window background
7030   sp.winfg          =         menu_pap   : rem Window foreground
7040   sp.winmg          =         menu_pap   : rem Window middleground
7050   sp.titlebg        =         menu_bar   : rem Title background
7060   sp.titletextbg=   menu_pap   : rem Title text background
7070   sp.titlefg        =         menu_ink   : rem Title foreground
7080   sp.litemhigh      =         menu_brd   : rem Loose item highlight
7090   sp.litemavabg =   menu_pap   : rem Loose item available background
7100   sp.litemavafg =   menu_ink   : rem Loex fifiose item available foreground
7110   sp.litemselbg =   menu_brd   : rem Loose item selected background
7120   sp.litemselfg =   menu_ink   : rem Loose item selected foreground
7130   sp.litemunabg =   menu_pap   : rem Loose item unavailable background
7140   sp.litemunafg =   menu_brd   : rem Loose item unavailable foreground
7150   sp.infwinbd       =         menu_brd   : rem Information window border
7160   sp.infwinbg       =         menu_pap   : rem Information window background
7170   sp.infwinfg       =         menu_ink   : rem Information window foreground
7180   sp.infwinmg       =         menu_pap   : rem Information window foreground
7190   sp.subinfbd       =         menu_brd   : rem Information window border (sub)
7200   sp.subinfbg       =         menu_pap   : rem Information window background
7210   sp.subinffg       =         menu_ink   : rem Information window foreground
7220   sp.subinfmg       =         menu_pap   : rem Information window foreground
7230   sp.appbd          =         menu_brd   : rem Application window border
7240   sp.appbg          =         menu_pap   : rem Application window background
7250   sp.appfg          =         menu_ink   : rem Application window foreground
7260   sp.appmg          =         menu_pap   : rem Application window middleground
7270   sp.appihigh       =         menu_ink   : rem Application window item highlight
7280   sp.appiavabg      =         menu_pap   : rem Application window item available background
7290   sp.appiavafg      =         menu_ink   : rem Application window item available foreground
7300   sp.appiselbg      =         menu_brd   : rem Application window item selected background
7310   sp.appiselfg      =         menu_ink   : rem Application window item selected foreground
7320   sp.appiunabg      =         menu_pap   : rem Application window item unavailable background
7330   sp.appiunafg      =         menu_brd   : rem Application window item unavailable foreground
7340   sp.scrbar         =         menu_ink   : rem Pan/scroll bar
7350   sp.scrbarsec      =         menu_pap   : rem bar section
7360   sp.scrbararr      =         menu_brd   : rem Pan/scroll bar arrow
7370   sp.buthigh        =         menu_ink   : rem Button highlight
7380   sp.butbd          =         menu_brd   : rem Button border
7390   sp.butbg          =         menu_pap   : rem Button background
7400   sp.butfg          =         menu_ink   : rem Button foreground
7410   sp.hintbd         =         menu_brd   : rem Hint border
7420   sp.hintbg         =         menu_ink   : rem Hint background
7430   sp.hintfg         =         menu_pap   : rem Hint foreground
7440   sp.hintmg         =         menu_ink   : rem Hint middleground
7450   sp.errbg          =         menu_inv   : rem Error message background
7460   sp.errfg          =         menu_ink   : rem Error message foreground
7470   sp.errmg          =         menu_ink   : rem Error message middleground
7480   sp.shaded         =         0            : rem sp.shaded area
7490   sp.3ddark         =         0            : rem Dark 3D border shade
7500   sp.3dlight        =         white        : rem Light 3D border shade
7510   sp.vertfill       =         menu_pap   : rem Vertical area fill
7520   sp.subtitbg       =         menu_pap   : rem Subtitle background
7530   sp.subtittxtbg=   menu_pap   : rem Subtitle text background
7540   sp.subtitfg       =         menu_ink   : rem Subtitle foreground
7550   sp.mindexbg       =         menu_pap   : rem Menu index background
7560   sp.mindexfg       =         menu_brd   : rem same,        foreground
7570   sp.separator      =         menu_brd   : rem Seperator lines etc.
7580 end def make_my_old_palette
7590 :
7600 DEFine FuNction getstr$(poste%,drap%,defn,a$)
7610 REMark opens and sets a window over a loose item and proposes a sting to be edited.
7620 REMark parameters:
7630 REMark - item nbr
7640 REMark - falg whether result MUST be a numbrr (flag<>0)
7650 REMark - the working definition
7660 REMark - the string o edit
7670 rem returns the string or ""
7680 rem uses the global (!) vars sp.litemselbg and sp.litemselfg
7690 rem
7700 local b$,chan%
7710   chan%=FOPEN("con")
7720   b$=getstr2$(poste%,drap%,defn,a$,chan%)
7730   close#chan%
7740   return b$
7750 END DEFine getstr$
7760 :
7770 DEFine FuNction getstr2$(poste%,drap%,defn,a$,chan%)
7780 REMark sets a window over a loose item and proposes a sting to be edited.
7790 REMark parameters:
7800 REMark - item nbr
7810 REMark - falg whether result MUST be a numbrr (flag<>0)
7820 REMark - the working definition
7830 REMark - the string o edit
7840 remark - a screen channel to be used
7850 rem returns the string or ""
7860 rem uses the global (!) vars sp.litemselbg and sp.litemselfg
7870 rem
7880   LOCal b$,res
7890   b$=" ":b$=a$           : REMark c'est curieusement ncessaire
7900   wm_PAPER#chan%,sp.litemselbg
7910   wm_INK#chan%,sp.litemselfg
7920   DR_LWDF#chan%,defn,poste%             : rem open channel over item
7930   CLS#chan%
7940   res=GET_STR(#chan%,drap%,b$)                                : rem get string
7950   IF res<0:b$=""                        : rem ooops
7960   CH_ITEM defn,-1,poste%,-1,"",b$
7970   RETurn b$
7980 END DEFine getstr2$
7990 :
8000 def fn showcont$(string$,length%)
8010 rem this adds '...' at the end of a string, to show that it continues
8020 local l%,lengt%
8030   l%=len(string$)
8040   if not l%:return ""                             : rem empty string
8050   lengt%=length% div 6
8060   if l%<=lengt%:return string$                    : rem entire string fits wdw
8070   return string$(1 to lengt%-3)&"..."
8080 end def showcont$
8090 :
8100 def fn get_free_text$(defn,item%,prompt$,length%)
8110 rem this opens wdw over loose-item item% of the working definition defn
8120 rem allows free text to be entered
8130 rem params: working defintion,item over which wdw is to be opened
8140 rem           first value of string, length of max string in wdw, if this is...
8150 rem              -1, the length will be determined here
8160 local chan%,string$,tempsizes%(3)
8170   chan%=fopen('con')
8180   if chan%<0:return prompt$
8190   dr_lwdf#chan%,defn,item%              : rem open wdw over item
8200   paper#chan%,menu_brd
8210   ink#chan%,menu_ink
8220   cls#chan%
8230   string$=wedit$(#chan%,prompt$)
8240   if length%=-1
8250      wsipo#chan%,tempsizes%
8260      length%=tempsizes%(0)
8270   endif
8280   close#chan%
8290   if length%
8300     ch_item defn,-1,item%,-1,"",showcont$(string$,length%)
8310   else
8320     ch_item defn,-1,item%,-1,"",string$
8330   endif
8340   return string$
8350 end def get_free_text$
8360 :
8370 DEFine FuNction centr$(ctr$,leng)
8380 rem this "centres" the string ctr$ (i.e. left padds it with spaces) so that
8390 rem it is centred in a window of leng width (leng is length in chars)
8400   LOCal l%,cta$
8410   cta$=strip_spaces$(ctr$)
8420   l%=INT(leng-LEN(cta$))/2
8430   if l%<0:return cta$
8440   return FILL$(' ',l%)&cta$&FILL$(' ',l%)
8450 END DEFine centr$
8460 :
8470 def fn set_colours% (force_mode%)
8480 rem this sets colour variables according to the colour mode wished, if possible.
8490 rem force_mode%=
8500 rem       0 if ql colours wished (mode 4 only)
8510 rem       1 if pal colours wished
8520 rem       2 if 24 bit colours wished
8530 rem This function returns the true QL mode set (4,8,32,33 etc.).
8540 rem This function also sets the GLOBAL variable mycolour_mode% to the
8550 rem mode 0,1,2 as above - whatever is possible on the machine, i.e.
8560 rem if colour_24 is wished on a 4 colour machine (which won't succeed)
8570 rem this function will set set that variable to 0, i.e. QL mode.
8580 rem
8590 rem This function needs the outptr toolkit
8600 local mode%
8610   mode%=rmode                                     : rem get current mode now
8620   select on force_mode%
8630       = 0                                         : rem mode 4 wished
8640        select on mode%
8650             = 4                                   : rem already on, so do nothing
8660             = 0,1,8 : mode 4            : rem old modes, set to 4 colours
8670             = remainder
8680               colour_ql                           : rem if higher colour mode, set to "mode 4"
8690               mode 4
8700        end select
8710        mode%=0                                    : rem new mode we're in  - 4 colour mode
8720       = 1                                         : rem PALette wished
8730        select on mode%
8740             = 16,32,33 : colour_pal:mode%=1  : rem we're in high colour mode, but PAL colours wished
8750             = remainder
8760               if mode%<>4:mode 4
8770               mode%=0
8780        end select
8790       = 2
8800        select on mode%
8810             = 32,33 : colour_24 :mode%=2          : rem we're in high col mode 24 bit colours
8820             = 16 : colour_pal : mode%=1
8830             = remainder
8840               if mode%<>4:mode 4
8850               mode%=0
8860        end select
8870   end select
8880   mycolour_mode%=mode%                            : rem set this global variable now:
8890   rem now set some colour variables
8900   select on mode%
8910        = 0                                        : rem Ql 4 mode colours
8920           Black            = 0
8930           White            = 7
8940           Red              = 2
8950           Green            = 4
8960           grey             = 255
8970           dull_pink      = 19
8980           Blue             = 0
8990           Magenta        = 2
9000           Yellow           = 7
9010           Cyan             = 0
9020           Dark_slate     = 0
9030           Slate_grey     = 255
9040           Dark_grey      = 255
9050           Light_grey     = 255
9060           Ash_grey       = 255
9070           Dark_red       = 210
9080           Light_green    = 220
9090           Mustard        = 242
9100           Dark_green     = 228
9110           Sea_blue       = 0
9120           Dark_blue      = 0
9130           Purple           = 0
9140           Shocking_pink  = 234
9150           Orange           = 234
9160           Lime_green     = 4
9170           Apple_green    = 4
9180           Bright_blue    = 0
9190           Mauve            = 0
9200           Peach            = 7
9210           Light_yellow   = 7
9220           Light_blue     = 0
9230           Sky_blue       = 0
9240           Rose_pink      = 234
9250           Pink             = 234
9260           Beige            = 7
9270           Pastel_pink    = 234
9280           Pastel_yellow  = 7
9290           Pastel_green   = 4
9300           Pastel_cyan    = 0
9310           Pastel_blue    = 0
9320           Pastel_rose    = 234
9330           Brick            = 210
9340           Light_khaki    = 7
9350           Dull_green     = 228
9360           Dull_cyan      = 0
9370           Steel_blue     = 0
9380           Dull_pink      = 234
9390           Brown            = 0
9400           Khaki            = 7
9410           Dusky_green    = 4
9420           Dusky_blue     = 0
9430           Midnight_blue  = 0
9440           Plum             = 0
9450           Dusky_pink     = 234
9460           Buff             = 0
9470           Avocado        = 4
9480           Dull_turquoise = 4
9490           Dull_blue      = 0
9500           Faded_purple   = 234
9510           Cerise           = 2
9520           Tan_normal     = 0
9530           Grass_green    = 4
9540           Sea_green      = 4
9550           Ultramarine    = 0
9560           Deep_purple    = 234
9570           Light_orange   = 7
9580           light_red      = 2
9590           wg_striped     = 92
9600           br_striped     = 82
9610           wr_striped     = 107
9620           bg_striped     = 100
9630        = 1                              : rem Colour_pal
9640           Black            = 0
9650           White            = 1
9660           Red              = 2
9670           Green            = 3
9680           Blue             = 4
9690           Magenta        = 5
9700           Yellow           = 6
9710           Cyan             = 7
9720           Dark_slate     = 8
9730           Slate_grey     = 9
9740           Dark_grey      = 10
9750           Grey             = 11
9760           Light_grey     = 12
9770           Ash_grey       = 13
9780           Dark_red       = 14
9790           Light_green    = 15
9800           Mustard        = 16
9810           Dark_green     = 17
9820           Sea_blue       = 18
9830           Dark_blue      = 19
9840           Purple           = 20
9850           Shocking_pink  = 21
9860           Orange           = 22
9870           Lime_green     = 23
9880           Apple_green    = 24
9890           Bright_blue    = 25
9900           Mauve            = 26
9910           Peach            = 27
9920           Light_yellow   = 28
9930           Light_blue     = 29
9940           Sky_blue       = 30
9950           Rose_pink      = 31
9960           Pink             = 32
9970           Beige            = 33
9980           Pastel_pink    = 34
9990           Pastel_yellow  = 35
10000           Pastel_green   = 36
10010           Pastel_cyan    = 37
10020           Pastel_blue    = 38
10030           Pastel_rose    = 39
10040           Brick            = 40
10050           Light_khaki    = 41
10060           Dull_green     = 42
10070           Dull_cyan      = 43
10080           Steel_blue     = 44
10090           Dull_pink      = 45
10100           Brown            = 46
10110           Khaki            = 47
10120           Dusky_green    = 48
10130           Dusky_blue     = 49
10140           Midnight_blue  = 50
10150           Plum             = 51
10160           Dusky_pink     = 52
10170           Buff             = 53
10180           Avocado        = 54
10190           Dull_turquoise = 55
10200           Dull_blue      = 56
10210           Faded_purple   = 57
10220           Cerise           = 58
10230           Tan_normal     = 59
10240           Grass_green    = 60
10250           Sea_green      = 61
10260           Ultramarine    = 62
10270           Deep_purple    = 63
10280           pinkish        = 77
10290           light_red      = 109
10300           Light_orange   = 208
10310           wg_striped     = light_green
10320           br_striped     = dark_red
10330           wr_striped     = light_red
10340           bg_striped     = dark_green
10350        = 2                              : rem colour_24
10360           Black            = hex('000000')
10370           White            = hex('FFFFFF')
10380           Red              = hex('FF0000')
10390           Green            = hex('00FF00')
10400           Blue             = hex('0000FF')
10410           Magenta        = hex('FF00FF')
10420           Yellow           = hex('FFFF00')
10430           Cyan             = hex('00FFFF')
10440           Dark_slate     = hex('242424')
10450           Slate_grey     = hex('494949')
10460           Dark_grey      = hex('6D6D6D')
10470           Grey             = hex('929292')
10480           Light_grey     = hex('B6B6B6')
10490           Ash_grey       = hex('DBDBDB')
10500           Dark_red       = hex('920000')
10510           Light_green    = hex('B6FFB6')
10520           Mustard        = hex('929200')
10530           Dark_green     = hex('009200')
10540           Sea_blue       = hex('009292')
10550           Dark_blue      = hex('000092')
10560           Purple           = hex('920092')
10570           Shocking_pink  = hex('FF0092')
10580           Orange           = hex('FF9200')
10590           Lime_green     = hex('92FF00')
10600           Apple_green    = hex('00FF92')
10610           Bright_blue    = hex('0092FF')
10620           Mauve            = hex('9200FF')
10630           Peach            = hex('FFB6B6')
10640           Light_yellow   = hex('FFFFB6')
10650           Light_blue     = hex('B6FFFF')
10660           Sky_blue       = hex('B6B6FF')
10670           Rose_pink      = hex('FFB6FF')
10680           Pink             = hex('FFB6DB')
10690           Beige            = hex('FFDBB6')
10700           Pastel_pink    = hex('FFDBDB')
10710           Pastel_yellow  = hex('FFFFDB')
10720           Pastel_green   = hex('DBFFDB')
10730           Pastel_cyan    = hex('DBFFFF')
10740           Pastel_blue    = hex('DBDBFF')
10750           Pastel_rose    = hex('FFDBFF')
10760           Brick            = hex('B66D6D')
10770           Light_khaki    = hex('B6B66D')
10780           Dull_green     = hex('6DB66D')
10790           Dull_cyan      = hex('6DB6B6')
10800           Steel_blue     = hex('6D6DB6')
10810           Dull_pink      = hex('B66DB6')
10820           Brown            = hex('6D2424')
10830           Khaki            = hex('6D6D24')
10840           Dusky_green    = hex('246D24')
10850           Dusky_blue     = hex('246D6D')
10860           Midnight_blue  = hex('24246D')
10870           Plum             = hex('6D246D')
10880           Dusky_pink     = hex('B64992')
10890           Buff             = hex('B69249')
10900           Avocado        = hex('92B649')
10910           Dull_turquoise = hex('49B692')
10920           Dull_blue      = hex('4992B6')
10930           Faded_purple   = hex('9249B6')
10940           Cerise           = hex('920049')
10950           Tan_normal     = hex('924900')
10960           Grass_green    = hex('499200')
10970           Sea_green      = hex('009249')
10980           Ultramarine    = hex('004992')
10990           Deep_purple    = hex('490092')
11000           Light_orange   = hex('ffb624')
11010           pinkish        = hex('C0037B')
11020           Light_red      = hex('FC1729')
11030           wg_striped     = light_green
11040           br_striped     = dark_red
11050           wr_striped     = light_red
11060           bg_striped     = dark_green
11070   end select
11080   mode%=rmode
11090   ret mode%                             : rem return current screen mode now
11100 end def set_colours%
11110 :
11120 DEFine FuNction fen_app2 (adresse,tableau$,nr_sects%,hit_do%,phys%)
11130 rem make a typical QPAC2 appsub wdw, with strings in the items
11140 rem the parameters are: the address (0 at first)
11150 rem the string array, the number of sections
11160 rem a flag whether hit=do (flag%=256)
11170 rem an integer array with x,y, sizes & origs
11180 rem a string with chars to be excluded from the selection keystrokes
11190 LOCal app_attributs%(3,1),temp%,bord%,pap%,ori_x%,ori_y%
11200 LOCal tail_x%,tail_y%,arrows%,bar%,bar_sect%,selk%
11210 :
11220   IF adresse:RECHP adresse              : rem if this is a second call, release old
11230   tail_x%=phys%(0)                      : rem x size  - just to make this clear
11240   tail_y%=phys%(1)                      : rem y "size"      we could use this directly
11250   ori_x%=phys%(2)                       : rem
11260   ori_y%=phys%(3)                       : rem origs x,y
11270 :
11280   adresse=AP_MAKE2(hit_do%,tail_x%,tail_y%,ori_x%,ori_y%,nr_sects%,tableau$)
11290   IF adresse<0: RETurn 0                : rem  error, return 0
11300 :
11310   bord%=sp.appbd                        : rem border colour
11320   pap%=sp.appbg                         : rem paper colour
11330   selk%=9                                         : rem selection keystroke, always TAB
11340   arrows%=sp.scrbararr                            : rem arrow colour
11350   bar%=sp.scrbar                        : rem bar colour
11360   bar_sect%=sp.scrbarsec                : rem bar section
11370 :
11380   app_attributs%(0,0)=1
11390   app_attributs%(0,1)=sp.appihigh       : rem current appsub wdw item border size & colour
11400 :
11410   app_attributs%(1,0)=sp.appiunabg
11420   app_attributs%(1,1)=sp.appiunafg      : rem unavailable
11430 :
11440   app_attributs%(2,0)=sp.appiavabg
11450   app_attributs%(2,1)=sp.appiavafg      : rem available
11460 :
11470   app_attributs%(3,0)=sp.appiselbg
11480   app_attributs%(3,1)=sp.appiselfg      : rem selected
11490 :
11500   er=AP_PARS(adresse,0,bord%,pap%,selk%,arrows%,bar%,bar_sect%,app_attributs%)
11510 :
11520   IF er:RETurn 0                        : rem OOOOPS
11530 :
11540   RETurn adresse                        : rem return the address!
11550 END DEFine fen_app2
11560 :
11570 DEFine PROCedure scroll_arrows(rangees%,nbr_objets%,appfen,cty%)
11580 rem Cette procdure dcide s'il faut laisser les flches de dfilement
11590 rem params: le nombre de ranges, le nombre total d'objets
11600 rem le pointer vers la sous-fen d'app et la dfinition de controle
11610   IF nbr_objets%<=rangees%
11620     POKE_W appfen+150,0       : rem no y offset to start of menu
11630     cty%(1,2)=nbr_objets%     : rem nbr of columns/rows
11640   ELSE
11650     POKE_W appfen+150,6
11660     cty%(1,2)=rangees%-1      : rem if scroll arrows are there, there is one line less in the window
11670   END IF
11680   IF DIMN(cty%,1)=2:cty%(2,2)=cty%(1,2)
11690   cty%(0,1)=1                            : rem show that definition has changed
11700 END DEFine scroll_arrows
11710 :
11720 DEFine PROCedure about_make (titre$,version$)
11730 rem this presupposes that wolfsoft_sprite is part of the sprites!
11740 local lxs%,lys%,xesp%,inf1y%,abt_lot,longueur_titre%,titre_x%
11750 local abt_iwt,abt_iot1,abt_iot2
11760   ab_xt%=200:ab_yt%=120    : REMark tailles x et y: la taille x devrait
11770                                    : REMark tre un chiffre divisible par 4
11780   lxs%=24:lys%=10                    : REMark tailles x et y pour postes standard
11790   inf1y%=lys%+4            : REMark posi. y de la fen. d'inf. intrieure
11800   xesp%=lxs%+2
11810   nbr_post%=0                      : REMark nombre de postes dans un coin
11820 :
11830 restore 11830
11840 :
11850   yinf1y%=inf1y%+4:
11860 :
11870   DIM abt_lfl%(0)
11880   abt_lot=RD_LOT(std_iattr,0)
11890     DATA ab_xt%-16,lys%,8,ab_yt%-lys%-8,0,0,cancel$,text+retr,'Super!'
11900 :
11910 : REMark  D'abord le titre qui est un objet d'une sous-fentre d'info.
11920 :
11930   longueur_titre%=LEN("Version "&version$)*6             : REMark on calcule la taille et la
11940   titre_x%=INT((ab_xt%-longueur_titre%)/2)  : REMark position x de cet objet
11950   abt_iot2=RD_IOT(1)
11960     DATA longueur_titre%,lys%,4,8,text,menu_ink,0,0,"Version "&version$
11970     DATA 52,24,ab_xt%-60,40,sprite,0,wolfsoft_sprite
11980   longueur_titre%=LEN(titre$)*6     : REMark on calcule la taille et la
11990   titre_x%=INT((ab_xt%-longueur_titre%)/2)  : REMark position x de cet objet
12000   abt_iot1=RD_IOT(0)
12010     DATA longueur_titre%,lys%,4,INT((lys%-10)/2),text,menu_ink,0,0,titre$
12020   abt_iwt=RD_IWT(2)               : REMark on veut 3 sous-fen. d'info
12030 REMark d'abord la fentre contenant la barre entourant le titre
12040     DATA ab_xt%-8-(2*nbr_post%*xesp%),lys%+2,xesp%*nbr_post%+4,0  : REMark taille x,y, origines x,y
12050     DATA 0,0,sp.infwinbd,sp.titlebg
12060                                    : REMark puis couleur papier
12070     DATA 0                         : REMark pointeur vers objets
12080 REMark maintenant la fentre qui contient le titre
12090     DATA longueur_titre%+8,lys%,titre_x%-2,2   : REMark on utilise titre_x% etc
12100     DATA 0,0, sp.infwinbd,sp.titlebg
12110     DATA abt_iot1                 : REMark un objet, le titre
12120 REMark maintenant la fentre de la bordure intrieure
12130     DATA ab_xt%-8,ab_yt%-inf1y%-2,4,inf1y%
12140     DATA 0,1, sp.infwinbd,sp.titlebg
12150     DATA abt_iot2
12160   abt_defn=RD_WDEF
12170     DATA 2,1,sp.winbd,sp.winbg
12180     DATA ab_xt%,ab_yt%,10,10 : REMark taille x,y et position pointeur
12190     DATA main_sprite,abt_lot,abt_iwt,0
12200 :
12210 end def about_make
12220 :
12230 DEFine PROCedure about
12240   LOCal loop%,item%,dummy%,chan%
12250   DR_PULD abt_defn,-1,-1,abt_lfl%
12260   chan%=fopen('con')
12270   dr_iwdf#chan%,abt_defn,2
12280   ink#chan%,menu_ink
12290   paper#chan%,menu_pap
12300   at#chan%,4,2
12310   print#chan%,"Copyright (c) 2003"
12320   at#chan%,5,2
12330   print#chan%,"W. Lenerz"
12340   close#chan%
12350   REPeat loop%
12360     RD_PTR abt_defn,item%,dummy%,dummy%,dummy%,dummy%,abt_lfl%
12370     SELect ON item%
12380             =0       : EXIT loop%
12390     END SELect
12400   END REPeat loop%
12410   DR_UNST abt_defn
12420 END DEFine about
12430 :
12440 DEFine FuNction RD_SPRT(drap%)
12450 REMark drap% determine si masque 0
12460   LOCal tmp_patt$(32,32)
12470   LOCal xs,ys,xo,yo, md, l
12480   READ ys,xs,xo,yo,md
12490   DIM tmp_patt$(ys,xs)
12500   FOR l=0 TO ys-1:READ tmp_patt$(l)
12510   l=ALCHP(SPRSP(xs,ys))
12520   SPSET l,xo,yo,md,tmp_patt$(0 TO ys-1,1 TO xs)
12530   IF drap%
12540     POKE_L l+16,espace_vide-(l+16)
12550   END IF
12560   RETurn l
12570 END DEFine RD_SPRT
12580 :
12590 DEFine FuNction RD_WDEF
12600 rem read window defn
12610   LOCal ldef%(3), lspr, lloose, linfo, lappl, lattr%(3)
12620   RD_WATT lattr%
12630   READ ldef%(0), ldef%(1), ldef%(2), ldef%(3)
12640   READ lspr, lloose, linf, lappl
12650   RETurn MK_WDEF (ldef%, lattr%, lspr, lloose, linf, lappl)
12660 END DEFine RD_WDEF
12670 :
12680 DEFine FuNction RD_LOT (lattr,nitem)
12690   LOCal count(3)
12700   LOCal item, ltyp, a$, lsk$
12710   LOCal ldef%(nitem,6), lptr(3,nitem), lstr$(nitem,85)
12720   lsk$=''
12730   FOR item = 0 TO nitem
12740     READ ldef%(item,0), ldef%(item,1), ldef%(item,2), ldef%(item,3)
12750     READ ldef%(item,4), ldef%(item,5)
12760     READ a$: lsk$=lsk$ & a$
12770     READ ltyp
12780     ldef%(item,6)=ltyp: ltyp=(ltyp MOD 256)/2
12790     IF ltyp>10 or ltyp <0:ltyp=0
12800     IF ltyp
12810       READ lptr(ltyp,count(ltyp))
12820     ELSE
12830       READ lstr$(count(0))
12840     END IF
12850     count(ltyp)=count(ltyp)+1
12860   END FOR item
12870   RETurn MK_LIL (lattr, ldef%(TO, 0 TO 1), ldef%(TO, 2 TO 3), ldef%(TO, 4 TO 5), lsk$, ldef%(TO, 6), lstr$, lptr(1), lptr(2), lptr(3))
12880 END DEFine RD_LOT
12890 :
12900 DEFine FuNction RD_IWT(nitem)
12910   LOCal item,mc1
12920   LOCal ldef%(nitem,3), latt%(nitem,3), lptr(nitem)
12930   FOR item = 0 TO nitem
12940     READ ldef%(item,0), ldef%(item,1), ldef%(item,2), ldef%(item,3)
12950     READ latt%(item,0), latt%(item,1), latt%(item,2), latt%(item,3)
12960     READ lptr(item)
12970   END FOR item
12980   RETurn MK_IWL (ldef%, latt%, lptr)
12990 END DEFine RD_IWT
13000 :
13010 DEFine FuNction RD_IOT(nitem)
13020   LOCal count(3)
13030   LOCal item, ltyp, work1, work2
13040   LOCal ldef%(nitem,4), lptr(3,nitem), lstr$(nitem,85)
13050   FOR item = 0 TO nitem
13060     READ ldef%(item,0), ldef%(item,1), ldef%(item,2), ldef%(item,3)
13070     READ ltyp
13080     ldef%(item,4)=ltyp:  ltyp=(ltyp MOD 256)/2
13090     IF ltyp >10:ltyp=0
13100     IF ltyp
13110       READ lptr(0,item),lptr(ltyp,count(ltyp))
13120     ELSE
13130       if mycolour_mode%=2
13140           read work1,work2,work3
13150           lptr(0,item)=WL_4_IOL(work1,work2,work3)
13160       else
13170           READ work1
13180           READ work2: work1=work1*256+work2
13190           READ work2: lptr(0,item)=work1*256+work2
13200       endif
13210       READ lstr$(count(0))
13220     END IF
13230     count(ltyp) = count(ltyp) + 1
13240   END FOR item
13250   RETurn MK_IOL (ldef%(TO, 0 TO 1), ldef%(TO, 2 TO 3), lptr(0), ldef%(TO, 4), lstr$, lptr(1), lptr(2), lptr(3))
13260 END DEFine RD_IOT
13270 :
13280 DEFine PROCedure RD_IATT (lattr)
13290   LOCal i
13300   READ lattr(0,0), lattr(0,1)
13310   FOR i=1 TO 3: READ lattr(i,0), lattr(i,1), lattr(i,2), lattr(i,3)
13320 END DEFine RD_IATT
13330 :
13340 DEFine PROCedure RD_WATT (lattr%)
13350   READ lattr%(0), lattr%(1),lattr%(2),lattr%(3)
13360 END DEFine RD_WATT
13370 :
13380 DEFine FuNction RD_APPW
13390   LOCal ldef%(3), lspr, sk$, lattr%(3)
13400   READ ldef%(0), ldef%(1), ldef%(2), ldef%(3)
13410   RD_WATT lattr%
13420   READ lspr, sk$
13430   RETurn MK_APPW (ldef%, lattr%, lspr,sk$)
13440 END DEFine
13450 :
